// Win32Library.h
//

#pragma once

BOOL FnGetOpenFileName(HWND hOwnerDlg, wchar_t* wszOpenFileName, wchar_t* wszErrorText);
BOOL FnGetSaveFileName(HWND hOwnerDlg, wchar_t* wszSaveFileName, wchar_t* wszErrorText);
BOOL FnBrowseForFolder(HWND hOwnerDlg, wchar_t* wszFolderNameForFind, wchar_t* wszErrorText);
BOOL FnChooseColor(HWND hMainDlg, COLORREF* pdwResultPtr, wchar_t* wszErrorText);
BOOL FnGetOpenFileHandle(HANDLE* phOpenFileHandlePtr, wchar_t* wszOpenFileName, wchar_t* wszErrorText);
BOOL FnGetSaveFileHandle(HANDLE* phSaveFileHandlePtr, wchar_t* wszSaveFileName, wchar_t* wszErrorText);
// ulong* pulOpenFileNumberPtr: ̕ϐɁAǂݎőoCgݒ肷B
// ulong* pulOpenFileNumberPtr: ̕ϐɁAۂɓǂݎoCgi[܂B
BOOL FnReadFile(HANDLE hOpenFileHandle, wchar_t* wszOpenFileName, wchar_t* awchOpenFileBufAry, ulong* pulOpenFileNumberPtr, wchar_t* wszErrorText);
// int iSaveFileBufCnt: t@CɏނׂoCgw肵܂
BOOL FnWriteFile(HANDLE hSaveFileHandle, wchar_t* wszSaveFileName, wchar_t* awchSaveFileBufAry, int nSaveFileBufCnt, wchar_t* wszErrorText);
// BOOL bFailIfExists: TRUE===>Õt@C݂ꍇARs[s܂
//                     FALSE===>̃t@C㏑
BOOL FnCopyFile(wchar_t* wszExistingFileName, wchar_t* wszNewFileName, BOOL bFailIfExists, wchar_t* wszErrorText);
//void FnGetPrivateProfileString(wchar_t* wszReturnedString, ulong* pulReturnSize);
BOOL FnDeleteFile(wchar_t* wszFileName, wchar_t* wszErrorText);
BOOL FnGetFileSize(HANDLE hFile, QUADWORD* punnFileSizePtr, wchar_t* wszErrorText);
// int iUniCodeTextCnt: Ch̕
// int* ipShiftJISTextCntPtr: obt@ɏ܂ꂽoCgԂ܂
BOOL FnWideChar2MultiByte(wchar_t* awchUnicodeAry, int nUniCodeAryCnt, char* achShiftJISAry, int* pnShiftJISAryCntPtr, BOOL* pbUsedFlagPtr, wchar_t* wszErrorText);
BOOL FnFindFirstFile(HANDLE* phFolderHandleForFindPtr, wchar_t* wszFolderNameForFind, WIN32_FIND_DATA* win32fdPtr, wchar_t* wszErrorText);
// ulong* pulShortPathCntPtr: obt@Ɋi[ꂽ̒Ch̐ŕԂ܂iI[ NULL jB
BOOL FnGetShortPathName(wchar_t* wszLongPath, wchar_t* wszShortPath, ulong* pulShortPathCntPtr, wchar_t* wszErrorText);
// int iShiftJISTextCnt: }bṽoCg
// int* ipUniCodeTextCntPtr: obt@ɏ܂ꂽCh̐Ԃ܂B
BOOL FnMultiByte2WideChar(char* achShiftJISAry, int nShiftJISAryCnt, wchar_t* awchUnicodeAry, int* pnUniCodeAryCntPtr, wchar_t* wszErrorText);
BOOL FnMoveFile(wchar_t* wszExistingFileName, wchar_t* wszNewFileName, wchar_t* wszErrorText);
BOOL FnCreateDIBSection(BITMAPINFOHEADER* pstrBitmapInfoHeaderPtr, HBITMAP* phBitmapPtr, uchar** pauchImageAryPtr , wchar_t* wszErrorText);
BOOL FnDeleteObject(HBITMAP hBitmap, wchar_t* wszErrorText);
void FnNumber2String(QUADWORD* punnNumberPtr, wchar_t* wszNumberText);
BOOL FnGetLockScreenMode(HKEY* phSubKeyPtr, DWORD* pulLockScreenDataPtr, wchar_t* wszErrorText);
BOOL FnSetLockScreenMode(HKEY hSubKey, DWORD ulLockScreenData, wchar_t* wszErrorText);
void FnCloseLockScreenMode(HKEY hSubKey);
BOOL FnGetSubKeyCount(const wchar_t* wszSubKeyText, ulong* pulSubKeyCount, wchar_t* wszErrorText);
BOOL FnQueryBlockSendersList(const wchar_t* wszSubKeyText, wchar_t* wszDataText, wchar_t* wszErrorText);
BOOL FnSetBlockSendersList(const wchar_t* wszSubKeyText, wchar_t* wszDataText, wchar_t* wszErrorText);
BOOL FnGetDC(HWND hMainWnd, HDC* phDeviceContextPtr, wchar_t* wszErrorText);
BOOL FnGetClientRect(HWND hMainWnd, RECT* pstrRectPtr, wchar_t* wszErrorText);
BOOL FnReleaseDC(HWND hMainWnd, HDC hDeviceContext, wchar_t* wszErrorText);
BOOL FnCreateCompatibleDC(HDC hWinDeviceContext, HDC* phBmpDeviceContextPtr, wchar_t* wszErrorText);
BOOL FnCreateCompatibleBitmap(HDC hWinDeviceContext, HBITMAP* phBitmapPtr, RECT* pstrRectPackPtr, wchar_t* wszErrorText);
BOOL FnSelectObject(HDC hBmpDeviceContext, HBITMAP hBitmap, wchar_t* wszErrorText);
BOOL FnBitBlt(HDC hSrcDeviceContext, HDC hDstDeviceContext, BITCOPYPACK* pstrStrethPackPtr, wchar_t* wszErrorText);
BOOL FnStretchBlt(HDC hSrcDeviceContext, HDC hDstDeviceContext, BITCOPYPACK* pstrStrethPackPtr, wchar_t* wszErrorText);
BOOL FnOpenClipboard(HWND hMainWnd, wchar_t* wszErrorText);
BOOL FnEmptyClipboard(wchar_t* wszErrorText);
BOOL FnSetClipboardData(HBITMAP hBitmap, HANDLE* phClipboardDataPtr, wchar_t* wszErrorText);
BOOL FnCloseClipboard(wchar_t* wszErrorText);
BOOL FnIsClipboardFormatAvailable(wchar_t* wszErrorText);
BOOL FnDeleteDC(HDC hBitmapDeviceContext, wchar_t* wszErrorText);
BOOL FnGetClipboardData(HBITMAP* phBitmapPtr, wchar_t* wszErrorText);
BOOL FnCloseHandle(HANDLE hObject, wchar_t* wszErrorText);
BOOL FnGetObject(HBITMAP hBitmap, BITMAP* pBitmapPtr, wchar_t* wszErrorText);
BOOL FnGlobalLock(HGLOBAL hMemory, void** pvPointer, wchar_t* wszErrorText);
BOOL FnGlobalUnlock(HGLOBAL hMemory, wchar_t* wszErrorText);
void FnText2Integer(wchar_t* wszText, int* pnIntegerPtr);
BOOL FnRegisterClassEx(const WNDCLASSEX* pWndClassPtr, wchar_t* wszErrorText);

