// Win32Library.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include <windows.h>
#include <commdlg.h>
#include <shlobj.h>
#include <Cderr.h>
#include "..\Include\TypeDefinition.h"
#include "..\Include\Win32Library.h"
#include "..\Include\SubGrep.h"

// "This function or variable may be unsafe."\Ȃ
#pragma warning(disable : 4996)

const wchar_t* c_wszFilter = L"eLXg t@C(*.txt)\0*.txt\0摜t@C(*.BMP;*.JPG;*.GIF;*.TIF;*.PNG;*.ICO)\0*.BMP;*.JPG;*.GIF;*.TIF;*.PNG;*.ICO\0ׂẴt@C(*.*)\0*.*\0\0";
BOOL FnGetSaveFileName(HWND hOwnerDlg, wchar_t* wszSaveFileName, wchar_t* wszErrorText)
{
	OPENFILENAME ofn;
	DWORD	ulErrorCode;
	wchar_t  wszWorkText[TEXTLEN];
	BOOL    bResultState;

	SetLastError(NO_ERROR);
	memset(&ofn, 0, sizeof(OPENFILENAME));
	wcscpy(wszSaveFileName, L"");
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = hOwnerDlg;
	ofn.hInstance = NULL;
	ofn.lpstrFilter = c_wszFilter;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter = 0;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = wszSaveFileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle = L"t@C̕ۑ";
	ofn.Flags = OFN_OVERWRITEPROMPT;
	ofn.nFileOffset = 0;
	ofn.nFileExtension = 0;
	ofn.lpstrDefExt = NULL;
	ofn.lCustData = 0;
	ofn.lpfnHook = NULL;
	ofn.lpTemplateName = NULL;
	bResultState = GetSaveFileName(&ofn);
	if (!bResultState)
	{
		ulErrorCode = CommDlgExtendedError();
		// CDERR_GENERALCODES = &H0
		// The error involved a general common dialog box property
		if (CDERR_GENERALCODES == ulErrorCode)
		{
			wcscpy(wszErrorText, L"łB");
			return TRUE;
		}
		else
		{
			SubGetDialogErrorText(ulErrorCode, wszWorkText);
			wcscpy(wszErrorText, wszSaveFileName);
			wcscat(wszErrorText, L"JƂł܂B\nR: ");
			wcscat(wszErrorText, wszWorkText);
			return FALSE;
		}
	}
	else
	{
		wcscpy(wszErrorText, L"łB");
		return TRUE;
	}
}

BOOL FnBrowseForFolder(HWND hOwnerDlg, wchar_t* wszFolderNameForFind, wchar_t* wszErrorText)
{
	ITEMIDLIST* pItemIDListPtr;
	BROWSEINFO strBrowseInfo;
	DWORD	ulErrorCode;

	SetLastError(NO_ERROR);
	strBrowseInfo.hwndOwner = hOwnerDlg;
	strBrowseInfo.pidlRoot = NULL;
	strBrowseInfo.pszDisplayName = NULL;
	strBrowseInfo.lpszTitle = L"tH_̑I";
	strBrowseInfo.ulFlags = BIF_RETURNONLYFSDIRS;
	strBrowseInfo.lpfn = NULL;
	strBrowseInfo.lParam = 0;
	strBrowseInfo.iImage = CAST(int, NULL);
	pItemIDListPtr = SHBrowseForFolder(&strBrowseInfo);
	if (!pItemIDListPtr)
	{
		ulErrorCode = CommDlgExtendedError();
		// CDERR_GENERALCODES = &H0
		// The error involved a general common dialog box property
		if (CDERR_GENERALCODES == ulErrorCode)
		{
			SHGetPathFromIDList(pItemIDListPtr, wszFolderNameForFind);
			CoTaskMemFree(pItemIDListPtr);
			wcscpy(wszErrorText, L"łB");
			return TRUE;
		}
		else
		{
			SubGetDialogErrorText(ulErrorCode, wszErrorText);
			SHGetPathFromIDList(pItemIDListPtr, wszFolderNameForFind);
			CoTaskMemFree(pItemIDListPtr);
			return FALSE;
		}
	}
	else
	{
		SHGetPathFromIDList(pItemIDListPtr, wszFolderNameForFind);
		CoTaskMemFree(pItemIDListPtr);
		wcscpy(wszErrorText, L"łB");
		return TRUE;
	}
}

BOOL FnGetOpenFileHandle(HANDLE* phOpenFileHandlePtr, wchar_t* wszOpenFileName, wchar_t* wszErrorText)
{
	DWORD		ulErrorCode;
	wchar_t     wszErrorMessage[TEXTLEN];

	//G[NA
	SetLastError(NO_ERROR);
	*phOpenFileHandlePtr = CreateFile
	(
		wszOpenFileName,  // filename: 쐬܂͊JΏۂ̃IuWFNg̖OێĂANULL ŏI镶ւ̃|C^w肵܂B
		GENERIC_READ,  // DesiredAccess: IuWFNgւ̓ǂݎANZXw肵܂
		FILE_SHARE_READ,  // ShareMode: ȍ~AIuWFNgJƂƂɓǂݎANZXvꍇ̂݁Ȃ܂B 
		NULL,  // SecurityAttributes : ̃ZLeBLqqKp܂B
		OPEN_EXISTING,  // CreationDisposition: w肵t@C݂ĂȂꍇÅ֐͎s܂B
		FILE_ATTRIBUTE_NORMAL,  // FlagsAndAttributes: ̃t@Cɓɑݒ肵܂
		NULL  // TemplateFile: NULL w肵Ă
	);
	// ֐ƁA0 ȊO̒lԂ܂B
	if ((*phOpenFileHandlePtr) == INVALID_HANDLE_VALUE)
	{
		ulErrorCode = GetLastError();
		SubGetErrorMessage(ulErrorCode, wszErrorMessage);
		wcscpy(wszErrorText, wszOpenFileName);
		wcscat(wszErrorText, L"̓ǂݍ݃nh쐬邱Ƃł܂\nRF");
		wcscat(wszErrorText, wszErrorMessage);
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

BOOL FnGetSaveFileHandle(HANDLE* phSaveFileHandlePtr, wchar_t* wszSaveFileName, wchar_t* wszErrorText)
{
	DWORD		ulErrorCode;
	wchar_t     wszErrorMessage[TEXTLEN];

	//G[NA
	SetLastError(NO_ERROR);
	*phSaveFileHandlePtr = CreateFileW
	(
		wszSaveFileName,  // filename: 쐬܂͊JΏۂ̃IuWFNg̖OێĂANULL ŏI镶ւ̃|C^w肵܂B
		GENERIC_WRITE,  // DesiredAccess: IuWFNgւ̏݃ANZXw肵܂B
		0,  // ShareMode: nhN[YȂAȍ~̂̃IuWFNgւ̃I[v͎s܂
		NULL,  // SecurityAttributes : nh͎qvZXɌp܂B
		CREATE_ALWAYS,  // CreationDisposition: Vt@C쐬܂Bw肵t@Cɑ݂ĂꍇÃt@C㏑Ȃ܂
		FILE_ATTRIBUTE_NORMAL,  // FlagsAndAttributes: The file does not have other attributes set
		NULL  // TemplateFile
	);
	// ֐ƁA0 ȊO̒lԂ܂B
	if ((*phSaveFileHandlePtr) == INVALID_HANDLE_VALUE)
	{
		ulErrorCode = GetLastError();
		SubGetErrorMessage(ulErrorCode, wszErrorMessage);
		wcscpy(wszErrorText, wszSaveFileName);
		wcscat(wszErrorText, L"̏onh쐬邱Ƃł܂\nRF");
		wcscat(wszErrorText, wszErrorMessage);
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

BOOL FnReadFile(HANDLE hOpenFileHandle, wchar_t* wszOpenFileName, wchar_t* awchOpenFileBufAry, ulong* pulOpenFileNumberPtr, wchar_t* wszErrorText)
{
	wchar_t     wszErrorMessage[TEXTLEN];
	DWORD		ulErrorCode;
	ulong       ulOpenFileNumber;
	BOOL        bResultState;

	//G[NA
	SetLastError(NO_ERROR);
	ulOpenFileNumber = *pulOpenFileNumberPtr;
	bResultState = ReadFile
	(
		hOpenFileHandle,  // HANDLE hFile: ǂݎΏۂ̃t@C̃nhw肵܂
		awchOpenFileBufAry,  // LPVOID lpBuffer: ̃obt@ɁAt@Cǂݎf[^i[܂B
		ulOpenFileNumber,  // ulong nNumberOfBytesToRead: ǂݎΏۂ̃oCgw肵܂B
		pulOpenFileNumberPtr,  // ulong* lpNumberOfBytesRead: ̕ϐɁAۂɓǂݎoCgi[܂B
		NULL  // LPOVERLAPPED lpOverlapped: 
	);
	if (!bResultState)
	{
		ulErrorCode = GetLastError();
		SubGetErrorMessage(ulErrorCode, wszErrorMessage);
		wcscpy(wszErrorText, wszOpenFileName);
		wcscat(wszErrorText, L"ǂލނƂł܂\nRF");
		wcscat(wszErrorText, wszErrorMessage);
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

BOOL FnWriteFile(HANDLE hSaveFileHandle, wchar_t* wszSaveFileName, wchar_t* awchSaveFileBufAry, int nSaveFileBufCnt, wchar_t* wszErrorText)
{
	wchar_t     wszErrorMessage[TEXTLEN];
	DWORD		ulErrorCode;
	BOOL        bResultState;
	ulong       ulBufCnt;

	//G[NA
	SetLastError(NO_ERROR);
	bResultState = WriteFile
	(
		hSaveFileHandle,  // hFile: ݑΏۂ̃t@C̃nhw肵܂B
		awchSaveFileBufAry,  // lpBuffer: t@Cɏނׂf[^ێĂobt@ւ̃|C^w肵܂B
		nSaveFileBufCnt,  // nNumberOfBytesToWrite: t@CɏނׂoCgw肵܂
		&ulBufCnt,  // lpNumberOfBytesWritten: ̕ϐɁAۂɏ܂ꂽoCgi[܂
		NULL  // lpOverlapped
	);

	if (!bResultState)
	{
		ulErrorCode = GetLastError();		SubGetErrorMessage(ulErrorCode, wszErrorMessage);
		wcscpy(wszErrorText, wszSaveFileName);
		wcscat(wszErrorText, L"oƂł܂\nRF");
		wcscat(wszErrorText, wszErrorMessage);
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

BOOL FnGetFileSize(HANDLE hFile, QUADWORD* punnFileSizePtr, wchar_t* wszErrorText)
{
	DWORD       ulFileSizeLow;
	DWORD       ulFileSizeHigh;
	DWORD		ulErrorCode;

	SetLastError(NO_ERROR);
	ulFileSizeHigh = NULL;
	ulFileSizeLow = GetFileSize(hFile, &ulFileSizeHigh);
	if (INVALID_FILE_SIZE == ulFileSizeLow)
	{
		ulErrorCode = GetLastError();
		wcscpy(wszErrorText, L"");
		SubGetErrorMessage(ulErrorCode, wszErrorText);
		return FALSE;
	}
	else
	{
		punnFileSizePtr->strQuadWord.ulLow = ulFileSizeLow;
		punnFileSizePtr->strQuadWord.ulHigh = ulFileSizeHigh;
		wcscpy(wszErrorText, L"łB");
		return TRUE;
	}
}

BOOL FnFindFirstFile(HANDLE* phFolderHandleForFindPtr, wchar_t* wszFolderNameForFind, WIN32_FIND_DATA* win32fdPtr, wchar_t* wszErrorText)
{
	wchar_t     wszErrorMessage[TEXTLEN];
	DWORD		ulErrorCode;
	wchar_t     wszPathForFind[TEXTLEN];

	wcscpy(wszPathForFind, wszFolderNameForFind);
	wcscat(wszPathForFind, L"\\*.*");
	//G[NA
	SetLastError(NO_ERROR);
	*phFolderHandleForFindPtr = FindFirstFile(wszPathForFind, win32fdPtr);
	if ((*phFolderHandleForFindPtr) == INVALID_HANDLE_VALUE)
	{
		ulErrorCode = GetLastError();
		SubGetErrorMessage(ulErrorCode, wszErrorMessage);
		wcscpy(wszErrorText, wszFolderNameForFind);
		wcscat(wszErrorText, L"邱Ƃł܂\nRF");
		wcscat(wszErrorText, wszErrorMessage);
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}



BOOL FnMultiByte2WideChar(char* achShiftJISAry, int nShiftJISAryCnt, wchar_t* awchUnicodeAry, int* pnUniCodeAryCntPtr, wchar_t* wszErrorText)
{
	DWORD		ulErrorCode;
	int         nUniCodeAryCnt;
	wchar_t     wszErrorMessage[TEXTLEN];

	//G[NA
	SetLastError(NO_ERROR);
	nUniCodeAryCnt = *pnUniCodeAryCntPtr;
	(*pnUniCodeAryCntPtr) = MultiByteToWideChar
	(
		CP_ACP, // UINT CodePage,         R[hy[W ANSI R[hy[W
		MB_PRECOMPOSED, // ulong ulFlags, ̎ނw肷tO \ςݕ:{ƑȂ̑gݍ킹 
		achShiftJISAry, // LPCSTR lpMultiByteStr, // ϊ镶ւ̃|C^w肵܂
		nShiftJISAryCnt, // int cchMultiByte,      // ̃TCYoCgPʂœn܂
		awchUnicodeAry, // LPWSTR lpWideCharStr,  // ϊ̕󂯎obt@ւ̃|C^w肵܂
		nUniCodeAryCnt  // int cchWideChar        // obt@̃TCYCh̒PʂŎw肵܂
	);
	if (!(*pnUniCodeAryCntPtr))
	{
		ulErrorCode = GetLastError();
		SubGetErrorMessage(ulErrorCode, wszErrorMessage);
		wcscpy(wszErrorText, L"MultiByte2WideChar̃G[\nRF");
		wcscat(wszErrorText, wszErrorMessage);
		return FALSE;
	}
	wcscpy(wszErrorText, L"łB");
	return TRUE;
}

// ʓIȃ_CAO {bNX֐̎sɔŐṼG[܂B
void SubGetDialogErrorText(DWORD ulErrorCode, wchar_t* wszErrorText)
{
	switch (ulErrorCode)
	{
		//case CDERR_CANCELLATION:
		//	wcscpy(wszErrorText, L"LZ܂B");
		//	break;
	case CDERR_DIALOGFAILURE:
		wcscpy(wszErrorText, L"_CAO{bNX쐬ł܂łBDialogBox ֐ɑ΂R_CAO{bNX֐̌ĂяoɎs܂BƂ΁AR_CAO{bNX֐ĂяoۂɖȃEBhEnhw肷ƁA̒l܂B");
		break;
	case CDERR_FINDRESFAILURE:
		wcscpy(wszErrorText, L"\[XȂ̂ŁAR_CAO{bNX֐s܂");
		break;
	case CDERR_INITIALIZATION:
		wcscpy(wszErrorText, L"̍ۂɃR_CAO{bNX֐s܂BƂ΁As̏ꍇɔ܂B");
		break;
	case CDERR_LOADRESFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́Aw肳ꂽ\[X̃[hɎs܂");
		break;
	case CDERR_LOADSTRFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́Aw肳ꂽ̃[hɎs܂");
		break;
	case CDERR_LOCKRESFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́Aw肳ꂽ\[X̃bNɎs܂");
		break;
	case CDERR_MEMALLOCFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́A̍\̗p̃蓖Ăs܂ł");
		break;
	case CDERR_MEMLOCKFAILURE:
		wcscpy(wszErrorText, L"R_CAO{bNX֐́AnhɊ֘AtĂ郁bNł܂ł");
		break;
	case CDERR_NOHINSTANCE:
		wcscpy(wszErrorText, L"YR_CAO{bNXp̏\̂ Flags o ENABLETEMPLATE tOZbgĂ܂AΉCX^Xnh񋟂܂ł");
		break;
	case CDERR_NOHOOK:
		wcscpy(wszErrorText, L"YR_CAO{bNXp̏\̂ Flags o ENABLEHOOK tOZbgĂ܂AΉtbNvV[Ww|C^񋟂܂ł");
		break;
	case CDERR_NOTEMPLATE:
		wcscpy(wszErrorText, L"YR_CAO{bNXp̏\̂ Flags o ENABLETEMPLATE tOZbgĂ܂AΉev[g񋟂܂ł");
		break;
	case CDERR_REGISTERMSGFAIL:
		wcscpy(wszErrorText, L"R_CAO{bNX֐Ăяo RegisterWindowMessage ֐AG[R[hԂ܂");
		break;
	case CDERR_STRUCTSIZE:
		wcscpy(wszErrorText, L"YR_CAO{bNXp̏\̂ lStructSize oł");
		break;
	default:
		wsprintf(wszErrorText, L"RsȃG[ł:%0lx", ulErrorCode);
		break;
	}
}


void SubGetErrorMessage(DWORD ulErrorCode, wchar_t* wszErrorMessage)
{
	wchar_t* pwchErrMessagePtr;

	//G[\쐬
	FormatMessage
	(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | // ulong   ulFlags: ς݂̃bZ[Wi[Ă̂ɏ\ȃTCỸobt@IɊ蓖Ă܂
		FORMAT_MESSAGE_FROM_SYSTEM |  // VXebZ[We[u\[Xgp悤v܂ 
		FORMAT_MESSAGE_IGNORE_INSERTS, // ߍݑ}͖ߍ܂ꂸAbZ[W`̂܂܃obt@ɏo͂܂B
		NULL, // PCVOID  pSource: ̃p[^͖܂
		ulErrorCode,  // ulong   ulMessageID: 32rbg̃bZ[WIDw肵܂
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ulong   ulLanguageID: w肳ꂽIDƈv郁bZ[Wgp܂
		CAST(LPTSTR, &pwchErrMessagePtr), // PTSTR   pszBuffer: PVOID^ϐ̃AhXw肵܂B̊֐́ALocalAlloc֐găobt@IɊmۂ܂
		0, // ulong   nSize: obt@̍ŏTCYAoCgiUnicodeł̏ꍇ͕jŎw肵܂
		NULL // va_list* Arguments: }A32rbgl̔zւ̃|C^ƂĎw肵܂B
	);
	wcscpy(wszErrorMessage, pwchErrMessagePtr);
	LocalFree(pwchErrMessagePtr);
}



